{% extends 'base.html' %}

{% block title %}todo_vue_see.html{% endblock %}

{% block extra-style %}
<style>
    body {
        text-align: center;
        background-color: #ddd;
    }
    .inputBox {
        margin: auto;
        width: 70%;
        background: white;
        height: 50px;
        border-radius: 50px;
        line-height: 50px;
    }
    .inputBox .name {
        border-style: none;
        border-bottom: 1px solid #ddd;
        width: 90px;
        padding-left: 20px;
        line-height: 20px;
    }
    .inputBox .item {
        border-style: none;
        border-bottom: 1px solid #ddd;
        width: 400px;
        margin-left: 50px;
        padding-left: 20px;
        line-height: 20px;
    }
    .todoList {
        list-style: none;
        padding: 10px 0;
        text-align: left;
    }
    .todoList li {
        display: flex;
        height: 50px;
        line-height: 50px;
        margin: 0.5rem 0;
        padding: 0 0.9rem;
        background: white;
        border-radius: 5px;
    }
    .removeBtn {
        margin-left: auto;
        font-size: 20px;
    }
</style>
{% endblock %}

{% block content %}
<div id="app">
    <h1>ToDo</h1>
    <strong>오늘의 할 일</strong>
    <br>
    <div class="inputBox">
        <!-- 아래 vue와 데이터 디렉티브 바인딩을 위해 v-model 를 사용하여 vue data option name을 사용. -->
        <input class="name" type="text" placeholder="이름" v-model="name">
        <!-- enter를 사용하여 입력 -->
        <input class="item" type="text" placeholder="할 일을 입력하세요~" v-model="newTodoItem"
                v-on:keyup.enter="add_todo()">
        <!-- 버튼을 클릭하면 add_todo 메서드를 호출 -->
        <button v-on:click="add_todo()" class="btn btn-primary btn-sm">ADD</button>
    </div>
    <ul class="todoList">
        <!-- todoItems 안의 항목들 todo 에 하나씩 대입하여 순차실행 -->
        <li v-for="(todo, index) in todoItems">
            <span>{ todo.name }:: { todo.item }</span>
            <!-- 삭제 remove_todo() 함수 호출 -->
            <button class="removeBtn" type="button" v-on:click="remove_todo(index)">&#x00D7</button>
        </li>
    </ul>
</div>
{% endblock %}

{% block extra-script %}
<!-- 뷰 CDN 연결 -->
<script src="https://unpkg.com/vue/dist/vue.min.js"></script>
<script>
    var vm = new Vue({
        delimiters: ['{', '}'],
        el: '#app',   // element option에 태그 요소 지정하기
        // vue의 데이터 바인딩은 vue에서 html쪽으로 바인딩 반대는 안된다.
        // 예외로 v-model로 바인딩된 data는 양방향 가능하다.
        // 아래 name, newTodoItem은 v-model로 바인딩
        // todoItems는 v-for로 바인딩되고,
        // todoItems내 todo.name, todo.item은 mustache 기번문법으로 바인딩됨
        // 즉 v-model 외의 data 바이딩은 vue에서 html로 데이터 이동
        data: {
            name: '', // 아래 입력한 내용 넣기위해 input 태그에 v-model 속성사용
            newTodoItem: '',
            todoItems:[],
        },
        methods: {
            add_todo: function() {
                // 콘솔로그 확인 및 디버깅을 위해 로그저장
                console.log("add_todo() : ");
                // 입력된 이름이 없으면 경고창이 뜨고 리턴된다.
                if (this.name == "") {
                    alert("이름을 입력하세요!");
                    return;
                }
                if (this.newTodoItem == "") {
                    alert("내용을 입력하세요~");
                    return;
                }
                // todoItems 에 사용자가 입력한 내용 넣기
                this.todoItems.push({name: this.name, item: this.newTodoItem});
                // add push 후 입력항목 클리어하기
                this.name = "";
                this.newTodoItem = "";
            },
            remove_todo: function(index) {
                console.log("remove_todo() : ");
                this.todoItems.splice(index, 1);
            }
        },
    })
</script>
{% endblock %}
